#include <iostream>
#include <algorithm>

const int MAX_S = 1e4 + 10, MAX_N = 110;
const long long MAX_LL = 1e6;

long long knapsack[2 * MAX_S][MAX_N], a[MAX_N];

int main()
{
    std::cin.tie();
    std::ios_base::sync_with_stdio(false);

    int s, n;
    std::cin >> s >> n;
    for(int i = 1; i <= n; ++ i)
    {
        std::cin >> a[i];
    }

    std::sort(a, a + n);

    for(int i = 0; i < 2 * MAX_S; ++ i)
    {
        knapsack[i][0] = MAX_LL;
    }

    for(int i = 1; i <= s + a[n]; ++ i)
    {
        for(int j = 1; j <= n; ++ j)
        {
            if(a[j] > i)
            {
                knapsack[i][j] = knapsack[i][j - 1];
                continue;
            }
            knapsack[i][j] = std::min(knapsack[i][j - 1], knapsack[i - a[j]][j] + 1);
            //std::cout << knapsack[i][j] << ' ';
        }
        //std::cout << '\n';
    }

    long long min = knapsack[s][n];

    //std::cout << knapsack[60][n] << '\n';

    for(int i = s + 1; i <= s + a[n]; ++ i)
    {
        knapsack[i][n] += knapsack[i - s][n];
        if(knapsack[i][n] < min)
        {
            min = knapsack[i][n];
        }
    }

    //std::cout << knapsack[60][n] << '\n';

    std::cout << min << '\n';

    return 0;
}
/*
50 6
1 2 3 7 27 33
*/
