#include<iostream>
#include<cmath>
using namespace std;

int m[128];

int gcd(int a,int b)
{
    int r;
    while(b!=0)
    {
        r=a%b;
        a=b;
        b=r;
    }
    return a;
}

void extended_euclid(int a,int b,int &x1,int &y1)
{
    int q,r,x2,y2,t;
    x1=1; y1=0;
    x2=0; y2=1;

    while(b!=0)
    {
        q=a/b;
        r=a%b;
        a=b; b=r;
        t=x2; x2=x1-q*x2;
        x1=t;
        t=y2; y2=y1-q*y2;
        y1=t;
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int s,n;
    cin >> s >> n;

    for(int i=0; i<n; i++)
        cin >> m[i];

    int d,ans=1000000;
    for(int i=0; i<n; i++)
    {
        for(int j=i+1; j<n; j++)
        {
            if(s%m[i]==0)
            {
                ans=min(ans,s/m[i]);
                continue;
            }
            if(s%m[j]==0)
            {
                ans=min(ans,s/m[i]);
                continue;
            }

            d=gcd(m[i],m[j]);
            if(s%d==0)
            {
                int x1,y1;
                extended_euclid(m[i]/d,m[j]/d,x1,y1);
                x1*=s/d;
                y1*=s/d;
                x1=abs(x1);
                y1=abs(y1);
                while(x1>=0 and y1>=0)
                {
                    x1-=m[j];
                    y1-=m[i];
                }
                ans=min(ans,x1+y1+m[i]+m[j]);
            }
        }
    }

    cout << ans << endl;

    return 0;
}
